// inverterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "inverter.h"
#include "inverterDlg.h"
#include "magic.h"
#include "magicu.h"
#include "ToString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        enum { IDD = IDD_ABOUTBOX };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


/****************************************************************
Template names:
   S     2    0 
      X    X
   U     n    n
   ^     ^    ^
   |     |    |
   }     }    sar 0 or n
   |     |
   |     Power of 2 or arbitrary n
   |
   Signed or unsigned

%1: Divisor, as undecorated hex number
%2: Shift right value, as decimal number
%3: Bit mask for powers-of-2, as undecorated hex number   
****************************************************************/
static const CString Sn0( _T("      mov  eax,0%1h\r\n")
                          _T("      imul DWORD PTR dividend\r\n")
                          _T("      mov  eax, edx\r\n")
                          _T("      shr  eax, 31t\r\n")
                          _T("      add  eax, edx\r\n")
                        );

static const CString Snn( _T("      mov  eax,0%1h\r\n")
                          _T("      sar  edx, %2t\r\n")
                          _T("      imul DWORD PTR dividend\r\n")
                          _T("      mov  eax, edx\r\n")
                          _T("      shr  eax, 31t\r\n")
                          _T("      add  eax, edx\r\n")
                        );

                                 
static const CString S20( _T("      mov  eax, dividend\r\n")
                          _T("      cdq\r\n")
                          _T("      and  edx, 0%3h\r\n")
                          _T("      add  eax, edx\r\n")
                        );

static const CString S2n( _T("      mov  eax, dividend\r\n")
                          _T("      cdq\r\n")
                          _T("      and  edx, 0%3h\r\n")
                          _T("      add  eax, edx\r\n")
                          _T("      sar  eax, %2t\r\n")
                        );

static const CString Unn( _T("      mov  eax, 0%1h\r\n")
                          _T("      mul  DWORD PTR dividend\r\n")
                          _T("      mov  eax, edx\r\n")
                          _T("      shr  eax, %2t\r\n")
                        );

static const CString Un0( _T("      mov  eax, 0%1h\r\n")
                          _T("      mul  DWORD PTR dividend\r\n")
                          _T("      mov  eax, edx\r\n")
                        );

static const CString U2n( _T("      mov  eax, dividend\r\n")
                          _T("      shr  eax, %2t\r\n")
                        );


/****************************************************************************
*                         CinverterDlg::CinverterDlg
* Inputs:
*       CWnd * pParent: Parent dialog
*       
* Effect: 
*       Constructor
****************************************************************************/

CinverterDlg::CinverterDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CinverterDlg::IDD, pParent)
   {
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
   }

/****************************************************************************
*                         CinverterDlg::DoDataExchange
* Inputs:
*       CDataExchange * pDX: DDX object
* Result: void
*       
* Effect: 
*       Binds controls to variables
****************************************************************************/

void CinverterDlg::DoDataExchange(CDataExchange* pDX)
   {
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_DIVISOR, c_Divisor);
    DDX_Control(pDX, IDC_FLOAT_INVERSE, c_FloatInverse);
    DDX_Control(pDX, IDC_MULTIPLIER, c_Multiplier);
    DDX_Control(pDX, IDC_SAR, c_SAR);
    DDX_Control(pDX, IDC_FLOAT_INVERSE_OUT, c_FloatInverseOut);
    DDX_Control(pDX, IDC_DIVISOR_OUT, c_DivisorOut);
    DDX_Control(pDX, IDC_SAR_IN, c_SARIn);
    DDX_Control(pDX, IDC_MULTIPLIER_IN, c_MultiplierIn);
    DDX_Control(pDX, IDC_ASM, c_ASM);
    DDX_Control(pDX, IDC_SIGNED, c_Signed);
    DDX_Control(pDX, IDC_UNSIGNED, c_Unsigned);
    DDX_Control(pDX, IDC_COPY, c_Copy);
   }

/****************************************************************************
*                                 Message Map
****************************************************************************/

BEGIN_MESSAGE_MAP(CinverterDlg, CDialog)
        ON_WM_SYSCOMMAND()
        //}}AFX_MSG_MAP
        ON_EN_CHANGE(IDC_DIVISOR, &CinverterDlg::OnEnChangeDivisor)
        ON_WM_CLOSE()
        ON_EN_CHANGE(IDC_MULTIPLIER_IN, &CinverterDlg::OnEnChangeMultiplierIn)
        ON_EN_CHANGE(IDC_SAR_IN, &CinverterDlg::OnEnChangeSarIn)
        ON_BN_CLICKED(IDC_SIGNED, &CinverterDlg::OnBnClickedSigned)
        ON_BN_CLICKED(IDC_UNSIGNED, &CinverterDlg::OnBnClickedUnsigned)
        ON_BN_CLICKED(IDC_COPY, &CinverterDlg::OnBnClickedCopy)
END_MESSAGE_MAP()

/****************************************************************************
*                          CinverterDlg::OnInitDialog
* Result: BOOL
*       
* Effect: 
*       Initializes
****************************************************************************/

BOOL CinverterDlg::OnInitDialog()
   {
    CDialog::OnInitDialog();

    // Add "About..." menu item to system menu.
    
    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
       {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
           {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
           }
       }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);                 // Set big icon
    SetIcon(m_hIcon, FALSE);                // Set small icon
    
    LOGFONT lf;
    CFont * f;
    f = GetFont();
    f->GetLogFont(&lf);
    _tcscpy_s(lf.lfFaceName, _countof(lf.lfFaceName), _T("Courier New"));
    FixedFont.CreateFontIndirect(&lf);
    c_ASM.SetFont(&FixedFont);

    HBITMAP bmp = (HBITMAP)::LoadImage(AfxGetInstanceHandle(),
                               MAKEINTRESOURCE(IDB_COPY),
                               IMAGE_BITMAP,
                               0,0,
                               LR_LOADMAP3DCOLORS);
    c_Copy.SetBitmap(bmp);

    CheckRadioButton(IDC_SIGNED, IDC_UNSIGNED, IDC_SIGNED);
    updateControls();

    return TRUE;  // return TRUE  unless you set the focus to a control
   }

/****************************************************************************
*                          CinverterDlg::OnSysCommand
* Inputs:
*       UINT nID:
*       LPARAM lParam:
* Result: void
*       
* Effect: 
*       Handles system commands, in particular, the About Dialog
****************************************************************************/

void CinverterDlg::OnSysCommand(UINT nID, LPARAM lParam)
   {
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
       {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
       }
    else
       {
        CDialog::OnSysCommand(nID, lParam);
       }
   }

/****************************************************************************
*                         CinverterDlg::UpdateDivisor
* Result: void
*       
* Effect: 
*       Updates the controls for the divisor
****************************************************************************/

void CinverterDlg::UpdateDivisor()
    {
     CString s;
     c_Divisor.GetWindowText(s);
     int n = _ttoi(s);

     if(n != 0)
        { /* has inverse */
         struct ms mag;
         struct mu magu;

         mag = magic(n);
         magu = magicu((unsigned)n);

         if(c_Signed.GetCheck() == BST_CHECKED)
            { /* signed */
             s.Format(_T("%08x"), mag.M);
             c_Multiplier.SetWindowText(_T("0x") + s);
             c_MultiplierIn.SetWindowTextW(s);

             s.Format(_T("%d"), mag.s);
             c_SAR.SetWindowText(s);
             c_SARIn.SetWindowTextW(s);
            } /* signed */
         else
            { /* unsgined */
             s.Format(_T("%08x"), magu.M);
             c_Multiplier.SetWindowText(_T("0x") + s);
             c_MultiplierIn.SetWindowTextW(s);
             
             s.Format(_T("%d"), magu.s);
             c_SAR.SetWindowText(s);
             c_SARIn.SetWindowTextW(s);
            } /* unsgined */

         double inverse = 1.0 / (double)n;
         s.Format(_T("%g"), inverse);
         c_FloatInverse.SetWindowText(s);
         UpdateCode(n, mag, magu);
        } /* has inverse */
     
    } // CinverterDlg::UpdateDivisor

/****************************************************************************
*                       CinverterDlg::OnEnChangeDivisor
* Result: void
*       
* Effect: 
*       The divisor value has changed
****************************************************************************/

void CinverterDlg::OnEnChangeDivisor()
   {
    UpdateDivisor();
   }

/****************************************************************************
*                          CinverterDlg::IsPowerOf2
* Inputs:
*       DWORD divisor: Divisor value
* Result: BOOL
*       TEUE if power of 2
*       FALSE if not power of 2
****************************************************************************/

BOOL CinverterDlg::IsPowerOf2(DWORD divisor)
    {
     DWORD ones = 0;
     while(divisor != 0)
        { /* count ones */
         if(divisor & 0x1)
            ones++;
         divisor >>= 1;
        } /* count ones */
     return ones == 1;
    } // CinverterDlg::IsPowerOf2

/****************************************************************************
*                            CinverterDlg::OnCancel
* Result: void
*       
* Effect: 
*       Does nothing; prevents closing on <ESC>
****************************************************************************/

void CinverterDlg::OnCancel()
   {
    // Does nothing
   }

/****************************************************************************
*                              CinverterDlg::OnOK
* Result: void
*       
* Effect: 
*       Does nothing; prevents exiting on <Enter> key
****************************************************************************/

void CinverterDlg::OnOK()
   {
    // Does nothing
   }

/****************************************************************************
*                            CinverterDlg::OnClose
* Result: void
*       
* Effect: 
*       Closes the application
****************************************************************************/

void CinverterDlg::OnClose()
   {
    CDialog::OnOK();
   }

/****************************************************************************
*                         CinverterDlg::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CinverterDlg::updateControls()
    {
     CString s;
     c_MultiplierIn.GetWindowText(s);
     s.Trim();
     if(s.GetLength() != 8)
         { /* nothing */
          c_FloatInverseOut.SetWindowText(_T(""));
          c_DivisorOut.SetWindowTextW(_T(""));
         } /* nothing */
     else
         { /* has something */
          DWORD multiplier = _tcstoul(s, NULL, 16);

          multiplier--;  // remove compiler fudge factor

          c_SARIn.GetWindowText(s);
          s.Trim();
          int sar = 0;
          if(!s.IsEmpty())
             { /* convert */
              sar = _ttoi(s);
             } /* convert */

          double divisor = 0.0;
          double term = 0.5;
            
          while(multiplier != 0)
             { /* compute divisor */
              if(multiplier & 0x80000000)
                  divisor += term;
              term /= 2.0;
              multiplier <<= 1;
             } /* compute divisor */

          for(int i = 0; i < sar; i++)
              divisor /= 2.0;

          s.Format(_T("%g"), divisor);
          c_FloatInverseOut.SetWindowText(s);

          double inverse = 1.0 / divisor;
          s.Format(_T("%g"), inverse);
          c_DivisorOut.SetWindowText(s);
         } /* has something */
    }

/****************************************************************************
*                     CinverterDlg::OnEnChangeMultiplierIn
* Result: void
*       
* Effect: 
*       Handles changes on the multiplier input
****************************************************************************/

void CinverterDlg::OnEnChangeMultiplierIn()
    {
     updateControls();
    }

/****************************************************************************
*                        CinverterDlg::OnEnChangeSarIn
* Result: void
*       
* Effect: 
*       Handles changes in the shift value
****************************************************************************/

void CinverterDlg::OnEnChangeSarIn()
    {
     updateControls();
    }

/****************************************************************************
*                          CinverterDlg::UpdateCode
* Inputs:
*       DWORD divisor: divisor
*       struct ms & mag
*       struct mu & magu
* Result: void
*       
* Effect: 
*       Puts the code display in the code window
****************************************************************************/

void CinverterDlg::UpdateCode(DWORD divisor, struct ms & mag, struct mu & magu)
    {
     CString const * templ = NULL;
     DWORD mask = 0;
     int shift = 0;
     DWORD multiplier = 0;

     if(IsPowerOf2(divisor))
        { /* power of 2 */
         mask = divisor;
         mask--;
         if(c_Signed.GetCheck() == BST_CHECKED)
            { /* signed */
             // 0000 0100
             // sar is 2
             // mask is 0000 0011
             if(mag.s == 0)
                templ = &S20;
             else
                templ = &S2n;
             shift = mag.s + 1;
             multiplier = mag.M;
            } /* signed */
         else
            { /* unsigned */
             shift = log2(divisor);
             if(shift != 0)
                templ = &U2n;
             multiplier = magu.M;
            } /* unsigned */
        } /* power of 2 */
     else
        { /* not power of 2 */
         if(c_Signed.GetCheck() == BST_CHECKED)
            { /* signed */
             if(mag.s == 0)
                templ = &Sn0;
             else
                templ = &Snn;
             shift = mag.s;
             multiplier = mag.M;
            } /* signed */
         else
            { /* unsigned */
             if(magu.s == 0)
                templ = &Un0;
             else
                templ = &Unn;
             shift = magu.s;
             multiplier = magu.M;
            } /* unsigned */
        } /* not power of 2 */

     //****************************************************************
     // Now format the instructions
     //****************************************************************
     if(templ == NULL)
        { /* unsupported */
         CString s;
         s.LoadString(IDS_UNSUPPORTED);
         c_ASM.SetWindowText(s);
         return;
        } /* unsupported */
     else
        { /* has template */
         CString s;
         s.FormatMessage(*templ, ToString(_T("%08x"), multiplier), ToString(_T("%d"), shift), ToString(_T("%x"), mask));
         c_ASM.SetWindowText(s);
        } /* has template */
    } // CinverterDlg::UpdateCode

/****************************************************************************
*                       CinverterDlg::OnBnClickedSigned
* Result: void
*       
* Effect: 
*       Updates the code
****************************************************************************/

void CinverterDlg::OnBnClickedSigned()
    {
     UpdateDivisor();
    } // CinverterDlg::OnBnClickedSigned

/****************************************************************************
*                      CinverterDlg::OnBnClickedUnsigned
* Result: void
*       
* Effect: 
*       Updates the code
****************************************************************************/

void CinverterDlg::OnBnClickedUnsigned()
    {
     UpdateDivisor();
    } // CinverterDlg::OnBnClickedUnsigned

/****************************************************************************
*                             CinverterDlg::log2
* Inputs:
*       DWORD n: Value to compute
* Result: DWORD
*       log2(n)
* Notes:
*       The input must be a power-of-2
****************************************************************************/

DWORD CinverterDlg::log2(DWORD n)
    {
     DWORD log = 0;
     for(; n != 1; n >>= 1)
        log++;
     return log;
    } // CinverterDlg::log2


/****************************************************************************
*                        CinverterDlg::OnBnClickedCopy
* Result: void
*       
* Effect: 
*       Copies the edit control to the clipboard
****************************************************************************/

void CinverterDlg::OnBnClickedCopy()
    {
     c_ASM.SetRedraw(FALSE);
     int low;
     int high;
     c_ASM.GetSel(low, high);
     c_ASM.SetSel(0, -1);
     c_ASM.SendMessage(WM_COPY);
     c_ASM.SetSel(low, high);
     c_ASM.SetRedraw(TRUE);
    }
